<div class="register-container">
  <div class="close" (click)="closeDialog()"></div>
  <img [src]="'assets/logo/Windflower_Logo.png'" class="icon" />

  <div mat-dialog-content fxLayout="column" fxLayoutGap="20px">
    <h1 mat-dialog-title class="register-title">
      {{ 'form.register.title' | translate }}
    </h1>

    <div>
      <p class="registerFormInfo">
        {{ 'form.register.additionalInformation' | translate }}
      </p>
    </div>

    <div class="register-form">
      <form (ngSubmit)="register(data)">
        <!-- input field first name -->
        <mat-form-field>
          <mat-label>{{ 'form.label.firstName' | translate }}</mat-label>
          <input
            type="text"
            matInput
            [(ngModel)]="data.firstName"
            [ngModelOptions]="{ standalone: true }"
            required
            #firstName="ngModel"
          />
        </mat-form-field>

        <!-- first name is required error -->
        <mat-error
          *ngIf="firstName.invalid && (firstName.dirty || firstName.touched)"
          class="errors"
        >
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.firstName' | translate }}</p>
        </mat-error>

        <!-- input field last name -->
        <mat-form-field>
          <mat-label>{{ 'form.label.lastName' | translate }}</mat-label>
          <input
            type="text"
            matInput
            [(ngModel)]="data.lastName"
            [ngModelOptions]="{ standalone: true }"
            required
            #lastName="ngModel"
          />
        </mat-form-field>

        <!-- lastname is required error -->
        <mat-error
          *ngIf="lastName.invalid && (lastName.dirty || lastName.touched)"
          class="errors"
        >
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.lastName' | translate }}</p>
        </mat-error>

        <!-- mail input field -->
        <mat-form-field>
          <mat-label>{{ 'form.label.mail' | translate }}</mat-label>
          <input
            type="mail"
            matInput
            [(ngModel)]="data.mail"
            [ngModelOptions]="{ standalone: true }"
            required
            email
            #mail="ngModel"
          />
        </mat-form-field>

        <!-- valid email is required error -->
        <mat-error
          *ngIf="mail.invalid && (mail.dirty || mail.touched)"
          class="errors"
        >
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.mail' | translate }}</p>
        </mat-error>

        <!-- organization input field -->
        <div class="organization">
          <mat-form-field>
            <mat-label>{{ 'form.label.organization' | translate }}</mat-label>
            <mat-select
              #orga="ngModel"
              [ngModelOptions]="{ standalone: true }"
              [(ngModel)]="data.organizationId"
              required
              org
            >
              <mat-option
                *ngFor="let organization of organizations"
                [value]="organization.id"
              >
                <div class="icon-space">
                  <img
                    rel="icon"
                    type="image/x-icon"
                    [src]="organization.logo"
                  />
                  {{ organization.organizationName }}
                </div>
              </mat-option>
              <mat-option [value]="'0'">
                <button
                  class="no-text-transform-pill-button"
                  *ngIf="!newOrganizationSelected"
                  mat-stroked-button
                  (click)="newOrganization()"
                >
                  {{ 'newOrganization.create' | translate }}
                </button>
                <div *ngIf="newOrganizationSelected">
                  {{ orgaName }}
                </div>
              </mat-option>
            </mat-select>
          </mat-form-field>
        </div>
        <!-- organization invalid -->
        <mat-error *ngIf="!orga.value" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.organization' | translate }}</p>
        </mat-error>

        <p>{{ 'form.label.password' | translate }}</p>

        <!-- password input field -->
        <mat-form-field>
          <input
            matInput
            [type]="hide ? 'password' : 'text'"
            type="password"
            matInput
            [(ngModel)]="data.password"
            [ngModelOptions]="{ standalone: true }"
            required
            #pwd="ngModel"
          />
          <mat-icon matSuffix (click)="hide = !hide">{{
            hide ? 'visibility_off' : 'visibility'
          }}</mat-icon>
        </mat-form-field>

        <!-- password required error message -->
        <mat-error
          *ngIf="pwd.invalid && (pwd.dirty || pwd.touched)"
          class="errors"
        >
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.pwd' | translate }}</p>
        </mat-error>

        <!-- password contains not allowed letters error message -->
        <mat-error *ngIf="isInvalid(data.password)" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>

          <p>{{ 'error.register.invalid' | translate }}</p>
        </mat-error>

        <!-- Password to short error message -->
        <mat-error *ngIf="tooShort(data.password)" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>

          <p>{{ 'error.register.short' | translate }}</p>
        </mat-error>

        <!-- Terms and conditions text -->
        <mat-checkbox
          #privacyConsent="ngModel"
          (change)="updatePolicyShowErrorHint($event)"
          [(ngModel)]="userAgreesPolicyConsent"
          [ngModelOptions]="{ standalone: true }"
          required
        >
          <div class="user-consent">
            <p>
              {{ 'form.register.acceptDataPolicy' | translate
              }}<span (click)="goToDeclarationPage()">{{
                'form.register.acceptDataPolicyLink' | translate
              }}</span>
            </p>
          </div>
        </mat-checkbox>

        <!-- Terms and conditions not allowed error -->
        <mat-error *ngIf="showPrivacyErrorHint()" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.cst' | translate }}</p>
        </mat-error>

        <!-- Cookies Text -->
        <mat-checkbox
          #cookieConsent="ngModel"
          (change)="updateShowCookieErrorHint($event)"
          [(ngModel)]="userAgreesCookieConsent"
          [ngModelOptions]="{ standalone: true }"
          required
        >
          <div class="user-consent">
            <p>
              {{ 'form.register.cookieConsent' | translate
              }}<span
                ><a
                  id="cookieLink"
                  href="https://www.allaboutcookies.org"
                  target="_blank"
                  >{{ 'form.register.cookieConsentLink' | translate }}</a
                ></span
              >
            </p>
          </div>
        </mat-checkbox>

        <!-- Cookies not allowed error -->
        <mat-error *ngIf="showCookieErrorHint()" class="errors">
          <mat-icon>{{ 'warning' }}</mat-icon>
          <p>{{ 'error.register.cookie' | translate }}</p>
        </mat-error>

        <!-- Register Button -->
        <div class="register-button">
          <button
            mat-raised-button
            class="pill-button"
            type="submit"
            color="primary"
            (click)="register(data)"
            [disabled]="
              firstName.invalid ||
              lastName.invalid ||
              mail.invalid ||
              pwd.invalid ||
              !privacyConsent.value ||
              !cookieConsent.value ||
              isInvalid(data.password) ||
              tooShort(data.password)
            "
          >
            {{ 'form.label.register' | translate }}
          </button>
        </div>
      </form>
    </div>
  </div>
</div>
